/* This driver program tests recursive function factorial().
 
Input:  an integer n
Output: n! (or error message if n < 0)
--------------------------------------------------------------------*/

#include <iostream>     // cout, cin, <<, >>
#include <cassert>      // assert()
using namespace std;

int factorial(int n);

int main() 
{ 
  cout << "This program tests a recursive factorial function...\n\n"; 

  int number;
  char more;

  do
  {
    cout << "]nEnter an integer: ";
    cin >> number;
    cout << number << "! = " << factorial(number) << endl;
    cout << "More (Y or N)? ";
    cin >> more;
  }
  while (more == 'Y' || more == 'y');
}

/* factorial computes n! recursively.

   Receive:      n, a nonnegative integer
   Precondition: n >= 0
   Return:       n!
-----------------------------------------------*/

int factorial(int n)
{
  assert(n >= 0);
  if (n == 0)
    return 1;                     // anchor case
  else
    return n * factorial(n-1);    // inductive step
}
